#include <stdio.h>
#include <stdlib.h>

int main()
{
    long long n,k,a[10000],b[10000],x=1;
    scanf("%lld%lld",&n,&k);
    for(long long i=0;i<k;i++)
        scanf("%lld",&a[i]);
    for(long long i=0;i<n;i++){
            x=1;
        for(long long j=2;j<=a[i];j++){
            if(a[i]%j==0)
                x=x^j;
        }
        b[i]=x;
    }
    for(long long i=0;i<k;i++)
        printf("%lld ",b[i]);
    return 0;
}